#include <stdio.h>
int n=2048,m;
double x[2048],y[2048],z[4],w[4];
main(int ac,char **av)
{
  int i;
  if(ac<2){ printf("\n\t **** minium 2 method *****\n");
            printf("\n\t Usage: mini2 1,2,3,4\n\n"); exit(0); }
  sscanf(av[1],"%d",&m);
  w[0]=1.23;  w[1]=2.34;  w[2]=3.45;  w[3]=4.56; 
  for(i=0;i<n;i++){
    x[i]=1.0*i;
    y[i]=w[0];
    if(m>1)y[i]+=w[1]*x[i];
    if(m>2)y[i]+=w[2]*x[i]*x[i];
    if(m>3)y[i]+=w[3]*x[i]*x[i]*x[i];
  }
  printf("start: "); for(i=0;i<m;i++)printf("%5.3f ",w[i]); printf("\n");
  mini2(x,y,n, z,m);
  printf("calcu: "); for(i=0;i<m;i++)printf("%5.3f ",z[i]); printf("\n");
}

//  sig(x^4)*a + sig(x^3)*b + sig(x^2)*c = sig(x^2*y)
//  sig(x^3)*a + sig(x^2)*b + sig(x)*c   = sig(x*y)
//  sig(x^2)*a + sig(x)*b   + n*c        = sig(y)    
mini2(xx,yy,n, zz,mini)
double *xx,*yy,*zz; int n,mini;
{
  int i;
  double sy,sxy,sx2y,sx3y,  sx,sx2,sx3,sx4,sx5,sx6,  x,x2,x3,x4,x5,x6,y;
  double a[4][4],b[4];
  sy=sxy=sx2y=sx3y= sx=sx2=sx3=sx4=sx5=sx6=0.;
  for(i=0;i<n;i++){
    x=xx[i]; y=yy[i];
    x2=x*x;  x3=x2*x;   x4=x2*x2;   x5=x2*x3;  x6=x3*x3;
    sy+=y;   sxy+=x*y;  sx2y+=x2*y; sx3y+=x3*y; 
    sx+=x;   sx2+=x2;   sx3+=x3;    sx4+=x4;   sx5+=x5;  sx6+=x6;
  }
  a[0][0]=n;   a[0][1]=sx;  a[0][2]=sx2; a[0][3]=sx3;
  a[1][0]=sx;  a[1][1]=sx2; a[1][2]=sx3; a[1][3]=sx4;
  a[2][0]=sx2; a[2][1]=sx3; a[2][2]=sx4; a[2][3]=sx5;
  a[3][0]=sx3; a[3][1]=sx4; a[3][2]=sx5; a[3][3]=sx6;
  b[0]=sy;     b[1]=sxy;    b[2]=sx2y;   b[3]=sx3y;
  matrix(a,b,mini);
  for(i=0;i<mini;i++)z[i]=b[i];
}
     
matrix(a,b,m)
double a[][4],*b; int m;
{
  int i,j,k,l; double s,t;
  for(i=0;i<m-1;i++){ s=0.;
    for(k=i;k<m;k++){ t=a[k][i]; if(t<0.)t=-t; if(t>s){ s=t; l=k; } }
    if(s==0.){ for(k=0;i<m;k++)b[k]=0; printf("Matrix err\n"); return; }
    if(i!=l){
      for(j=0;j<m;j++){ t=a[i][j]; a[i][j]=a[l][j]; a[l][j]=t;}
      t=b[i]; b[i]=b[l]; b[l]=t;
    } s=a[i][i];
    for(j=i+1;j<m;j++){
      t=a[j][i]/s; b[j]-=t*b[i];
      for(k=i;k<m;k++)a[j][k]-=t*a[i][k];
    }
  }
for(j=0;j<m;j++){ for(i=0;i<m;i++)printf("%15.4le",a[j][i]); printf("\n"); }
  for(i=0;i<m;i++){ l=m-1-i;
    if(a[l][l]==0.){ b[l]=0.; continue; }
    t=b[l]; if(l!=m-1)for(j=1;j<=i;j++){ k=m-j; t-=a[l][k]*b[k]; }
    b[l]=t/a[l][l];
  }
}
